# Copyright: 2007-2010 Paul Obermeier (obermeier@poSoft.de)
# Extended for Excel 2007 by Cary WR Campbell - July 2, 2009
# Distributed under BSD license.
#
# This script can be used to create all needed constants for the TcomExcel
# package.
# You may need to have to change the path to the type library of Excel used
# in the import command.
#
# Usage: tclsh createConstFile.tcl > excelConst.tcl

package require tcom

tcom::import "C:/Program Files/Microsoft Office/Office12/Excel.exe" paul

set len [expr 4 + 2*2] ; # 4 characters for paul; 2*2 characters for ::

puts "# Auto generated by createConstFile.tcl based on the type library"
puts "# of Excel in Office 2007."
puts "#"
puts "# Copyright: 2007-2010 Paul Obermeier (obermeier@poSoft.de)"
puts "# Distributed under BSD license."
puts ""
puts "package provide tcomexcel 0.3"
puts ""
puts "namespace eval ::Excel {"

foreach arr [lsort [info vars paul::*]] {
    puts ""
    puts "    # Enumeration [string range $arr $len end]"
    foreach key [lsort [array names $arr *]] {
        set cmd [format "set val \$%s(%s)" $arr $key]
        eval $cmd
        puts "    variable $key $val"
    }
}

puts "}"
exit 0
